import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
public class HalfSky extends Applet{
    XCanvas xc;
    ImgFrame imgfr;
    Image boden;
    Image bomb;
    static HalfSky app;
    public void init(){
        app=this;
        resize(800,440);
        setLayout(null);
        boden=getImage("boden.gif");
        bomb=getImage("bomb.gif");
        imgfr=new ImgFrame();
        MediaTracker tracker=new MediaTracker(this);
        tracker.addImage(boden,0);
        tracker.addImage(bomb,0);
        try{
            tracker.waitForID(0);
        }
        catch(Exception e){}
        xc=new XCanvas(this);
        add(xc);
        xc.reshape(0,40,800,400);
        show();
        requestFocus();
    }
    public static Image getImage(String filename){
        try{
            URL url=HalfSky.app.getClass().getResource("/"+filename);
            Image img=HalfSky.app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public static void main(String[]args){
        new HalfSky();
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            xc.keycode=evt.key;
        }
        if(evt.id==Event.WINDOW_DESTROY){
            xc.running=false;
            System.exit(0);
        }
        return false;
    }
}
class XCanvas extends Canvas implements Runnable{
    HalfSky hs;
    Thread t;
    boolean running=true;
    Gegner[]gegners;
    Bomb[]bombs;
    int[]starsx;
    int[]starsy;
    boolean[][]isboden;
    int xleft;
    int yleft;
    int xright;
    int yright;
    int gcount;
    int gspeed;
    int gsize;
    int gtness;
    int bcount;
    int scount;
    int bx;
    int by;
    double xpos;
    double ypos;
    int xposi;
    int yposi;
    double xdrift;
    double ydrift;
    double xdriftb;
    double ydriftb;
    double alpha;
    int driftp=0;
    double xposb;
    double yposb;
    int xposib;
    int yposib;
    double bxdrift;
    double bydrift;
    double bxdriftb;
    double bydriftb;
    double alphab;
    int driftpb=0;
    int speed;
    int size;
    int tness;
    int lifes;
    int lifesb;
    int destroyed;
    int gleft;
    boolean restart=false;
    boolean leavebomb=false;
    boolean leavebombb=false;
    boolean allbombsusedmessage=false;
    boolean fullsky=false;
    boolean ontrack=false;
    boolean ontrackb=false;
    boolean other=false;
    int keycode=0;
    KeyboardMapperApplet km=null;
    public XCanvas(HalfSky hs){
        this.hs=hs;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        hide();
        km=new KeyboardMapperApplet(hs);
        hs.add(km);
        km.reshape(0,40,400,400);
        km.show();
        while(!km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        show();
        requestFocus();
        initworld();
        while(running){
            try{
                for(int i=0;i<10;i++){
                    Thread.sleep(10);
                    if(keycode!=0){
                        if(!km.applyb){
                            process(keycode);
                        }
                        else{
                            process(km.getKeyCode(keycode));
                        }
                    }
                    keycode=0;
                }
            }
            catch(Exception e){
            }
            if(restart){
                restart=false;
                initworld();
            }
            step();
            repaint();
        }
    }
    public synchronized void initworld(){
        xleft=0;
        yleft=0;
        xright=1200;
        yright=1200;
        gcount=100;
        gspeed=2;
        gsize=8;
        gtness=3;
        bcount=40;
        scount=1000;
        bx=(xright-xleft)/20;
        by=(yright-yleft)/20;
        xpos=(double)(xleft+(xright-xleft)/2);
        ypos=(double)(yleft+(yright-yleft)/2);
        xposi=(int)xpos;
        yposi=(int)ypos;
        alpha=3.0*Math.PI/2.0;
        driftp=0;
        xposb=(double)(xleft+(xright-xleft)/2+40);
        yposb=(double)(yleft+(yright-yleft)/2);
        xposib=(int)xposb;
        yposib=(int)yposb;
        alphab=3.0*Math.PI/2.0;
        driftpb=0;
        speed=6;
        size=10;
        tness=4;
        lifes=3;
        lifesb=3;
        destroyed=0;
        gleft=gcount;
        gegners=new Gegner[gcount];
        bombs=new Bomb[bcount];
        starsx=new int[scount];
        starsy=new int[scount];
        isboden=new boolean[bx][by];
        leavebomb=false;
        allbombsusedmessage=false;
        fullsky=false;
        ontrack=false;
        other=false;
        xdriftb=0;
        ydriftb=-speed;
        bxdriftb=0;
        bydriftb=-speed;
        for(int i=0;i<gcount;i++){
            boolean search=true;
            double xt=0;
            double yt=0;
            while(search){
                xt=(Math.random()*(xright-xleft))+xleft;
                yt=(Math.random()*(yright-yleft))+yleft;
                double dista=Math.sqrt((xt-xpos)*(xt-xpos)+(yt-ypos)*(yt-ypos));
                if(dista>=100){
                    search=false;
                }
            }
            double at=Math.random()*Math.PI*2;
            gegners[i]=new Gegner(xt,yt,at,gspeed);
        }
        for(int i=0;i<scount;i++){
            starsx[i]=(int)((Math.random()*(xright-xleft))+xleft);
            starsy[i]=(int)((Math.random()*(yright-yleft))+yleft);
        }
        for(int i=0;i<bx;i++){
            for(int j=0;j<by;j++){
                int val=(int)(Math.random()*2);
                if(val==0){
                    isboden[i][j]=true;
                }
            }
        }
    }
    public synchronized void process(int key){
//System.out.println("key: "+key);
            if(key==Event.ESCAPE){
                restart=true;
            }
            if(key==Event.LEFT){
                if(fullsky||ontrack){
                    xdriftb=-speed;
                    ydriftb=0;
                    driftp=driftp-1;
                }
            }
            if(key==Event.RIGHT){
                if(fullsky||ontrack){
                    xdriftb=speed;
                    ydriftb=0;
                    driftp=driftp+1;
                }
            }
            if(key==Event.UP){
                if(fullsky||ontrack){
                    xdriftb=0;
                    ydriftb=-speed;
                }
            }
            if(key==Event.DOWN){
                if(fullsky||ontrack){
                    xdriftb=0;
                    ydriftb=speed;
                }
            }
            if(key==121){
                if(fullsky||ontrackb){
                    bxdriftb=-speed;
                    bydriftb=0;
                    driftpb=driftpb-1;
                }
            }
            if(key==99){
                if(fullsky||ontrackb){
                    bxdriftb=speed;
                    bydriftb=0;
                    driftpb=driftpb+1;
                }
            }
            if(key==115){
                if(fullsky||ontrackb){
                    bxdriftb=0;
                    bydriftb=-speed;
                }
            }
            if(key==120){
                if(fullsky||ontrackb){
                    bxdriftb=0;
                    bydriftb=speed;
                }
            }
            if(key==Event.ENTER||key==10||key==13){
                leavebomb=true;
            }
            if(key==97){
                leavebombb=true;
            }
            if(key==Event.DELETE){
                if(fullsky){
                    fullsky=false;
                }
                else{
                    fullsky=true;
                }
            }
            if(key==111){
                if(other){
                    driftp=0;
                    alpha=Math.PI*3/2.0;
                    driftpb=0;
                    alphab=Math.PI*3/2.0;
                    other=false;
                }
                else{
                    xdriftb=0;
                    ydriftb=-speed;
                    bxdriftb=0;
                    bydriftb=-speed;
                    other=true;
                }
            }
    }
    public void lifeminus(){
        if(lifes>0&&gleft>0){
            lifes=lifes-1;
            if(lifes<=0&&lifesb<=0){
                bombs=new Bomb[bcount];
            }
        }
        xpos=(double)(xleft+(xright-xleft)/2);
        ypos=(double)(yleft+(yright-yleft)/2);
        alpha=Math.PI*3.0/2.0;
        driftp=0;
        xdriftb=0;
        ydriftb=-speed;
    }
    public void lifeminusb(){
        if(lifesb>0&&gleft>0){
            lifesb=lifesb-1;
            if(lifes<=0&&lifesb<=0){
                bombs=new Bomb[bcount];
            }
        }
        xposb=(double)(xleft+(xright-xleft)/2+40);
        yposb=(double)(yleft+(yright-yleft)/2);
        alphab=Math.PI*3.0/2.0;
        driftpb=0;
        bxdriftb=0;
        bydriftb=-speed;
    }
    public synchronized void step(){
        if(driftp!=0){
            alpha=alpha+driftp*Math.PI/174.0;
            if(alpha<0){
                alpha=alpha+Math.PI*2.0;
            }
            if(alpha>Math.PI*2.0){
                alpha=alpha-Math.PI*2.0;
            }
        }
        xdrift=Math.cos(alpha)*speed;
        ydrift=Math.sin(alpha)*speed;
        if(driftpb!=0){
            alphab=alphab+driftpb*Math.PI/174.0;
            if(alphab<0){
                alphab=alphab+Math.PI*2.0;
            }
            if(alphab>Math.PI*2.0){
                alphab=alphab-Math.PI*2.0;
            }
        }
        bxdrift=Math.cos(alphab)*speed;
        bydrift=Math.sin(alphab)*speed;
        if(other){
            xdrift=xdriftb;
            ydrift=ydriftb;
            bxdrift=bxdriftb;
            bydrift=bydriftb;
        }
        xpos=xpos+xdrift;
        ypos=ypos+ydrift;
        xposi=(int)xpos;
        yposi=(int)ypos;
        xposb=xposb+bxdrift;
        yposb=yposb+bydrift;
        xposib=(int)xposb;
        yposib=(int)yposb;
        if((xposi<xleft)||(xposi>xright)||(yposi<yleft)||(yposi>yright)){
            lifeminus();
        }
        if((xposib<xleft)||(xposib>xright)||(yposib<yleft)||(yposib>yright)){
            lifeminusb();
        }
        int xdiff=xposi-xleft;
        int ydiff=yposi-yleft;
        if(xdiff>=0&&xdiff<bx*20&&ydiff>=0&&ydiff<by*20){
            xdiff=xdiff/20;
            ydiff=ydiff/20;
            if(isboden[xdiff][ydiff]){
                ontrack=true;
            }
            else{
                ontrack=false;
            }
        }
        else{
            ontrack=false;
        }
        int xdiffb=xposib-xleft;
        int ydiffb=yposib-yleft;
        if(xdiffb>=0&&xdiffb<bx*20&&ydiffb>=0&&ydiffb<by*20){
            xdiffb=xdiffb/20;
            ydiffb=ydiffb/20;
            if(isboden[xdiffb][ydiffb]){
                ontrackb=true;
            }
            else{
                ontrackb=false;
            }
        }
        else{
            ontrackb=false;
        }
        if(leavebomb&&lifes>0){
            leavebomb=false;
            int pos=0;
            boolean runi=true;
            while(runi&&pos<bcount){
                if(bombs[pos]==null){
                    runi=false;
                }
                else{
                    pos++;
                }
            }
            if(pos<bcount){
                bombs[pos]=new Bomb(xposi,yposi);
            }
            else{
                allbombsusedmessage=true;
            }
        }
        if(leavebombb&&lifesb>0){
            leavebombb=false;
            int posb=0;
            boolean runib=true;
            while(runib&&posb<bcount){
                if(bombs[posb]==null){
                    runib=false;
                }
                else{
                    posb++;
                }
            }
            if(posb<bcount){
                bombs[posb]=new Bomb(xposib,yposib);
            }
            else{
                allbombsusedmessage=true;
            }
        }
        int bcounter=0;
        for(int i=0;i<bcount;i++){
            if(bombs[i]!=null){
                bcounter=bcounter+1;
                boolean bval=(lifesb>0)&&(xposib>=bombs[i].xpos-10)&&(xposib<=bombs[i].xpos+10)&&(yposib>=bombs[i].ypos-10)&&(yposib<=bombs[i].ypos+10);
                if(bval||((lifes>0)&&(xposi>=bombs[i].xpos-10)&&(xposi<=bombs[i].xpos+10)&&(yposi>=bombs[i].ypos-10)&&(yposi<=bombs[i].ypos+10))){
                    if(bombs[i].isover){
                    }
                    else{
                        bombs[i]=null;
                    }
                }
                else{
                    bombs[i].isover=false;
                }
            }
        }
        if(bcounter<bcount){
            allbombsusedmessage=false;
        }
        for(int i=0;i<gcount;i++){
            if(gegners[i]!=null){
                gegners[i].move();
                if(gegners[i].xpos<xleft){
                    gegners[i].alpha=Math.PI*3.0/2.0-gegners[i].alpha+Math.PI*3.0/2.0;
                }
                if(gegners[i].xpos>xright){
                    gegners[i].alpha=Math.PI*3.0/2.0-gegners[i].alpha+Math.PI*3.0/2.0;
                }
                if(gegners[i].ypos<yleft){
                    gegners[i].alpha=Math.PI-gegners[i].alpha+Math.PI;
                }
                if(gegners[i].ypos>yright){
                    gegners[i].alpha=Math.PI-gegners[i].alpha+Math.PI;
                }
                double dist=Math.sqrt(((gegners[i].xpos-xpos)*(gegners[i].xpos-xpos))+((gegners[i].ypos-ypos)*(gegners[i].ypos-ypos)));
                if(dist<=size+gsize){
                    lifeminus();
                }
                dist=Math.sqrt(((gegners[i].xpos-xposb)*(gegners[i].xpos-xposb))+((gegners[i].ypos-yposb)*(gegners[i].ypos-yposb)));
                if(dist<=size+gsize){
                    lifeminusb();
                }
                for(int j=0;j<bcount;j++){
                    if(gegners[i]!=null&&bombs[j]!=null&&lifes>0){
                        if((gegners[i].xposi>=bombs[j].xpos-10)&&(gegners[i].xposi<=bombs[j].xpos+10)&&(gegners[i].yposi>=bombs[j].ypos-10)&&(gegners[i].yposi<=bombs[j].ypos+10)){
                            bombs[j]=null;
                            gegners[i]=null;
                            destroyed=destroyed+1;
                            gleft=gleft-1;
                        }
                    }
                }
            }
        }
    }
    public void paint(Graphics g){
    }
    public synchronized void update(Graphics g){
        Graphics h=hs.imgfr.img.getGraphics();
        h.setColor(Color.black);
        h.fillRect(0,0,800,400);
        h.setColor(Color.white);
        h.setClip(0,0,400,400);
        int basex=xposi-200;
        int basey=yposi-200;
        for(int i=0;i<scount;i++){
            if(starsx[i]>=basex&&starsx[i]<=basex+400&&starsy[i]>=basey&&starsy[i]<=basey+400){
                h.fillRect(starsx[i]-basex,starsy[i]-basey,1,1);
            }
        }
        for(int i=0;i<bx;i++){
            for(int j=0;j<by;j++){
                if(fullsky==false&&isboden[i][j]){
                    int xp=xleft+i*20;
                    int yp=yleft+j*20;
                    if((xp>=(basex-20))&&(xp<=(basex+420))&&(yp>=(basey-20))&&(yp<=(basey+420))){
                        h.drawImage(hs.boden,xp-basex,yp-basey,this);
                    }
                }
            }
        }
        for(int i=0;i<bcount;i++){
            if(bombs[i]!=null){
                int xpb=bombs[i].xpos;
                int ypb=bombs[i].ypos;
                if((xpb>=(basex-20))&&(xpb<=(basex+420))&&(ypb>=(basey-20))&&(ypb<=(basey+420))){
                    h.drawImage(hs.bomb,xpb-basex-10,ypb-basey-10,this);
                }
            }
        }
        for(int i=0;i<gcount;i++){
            if(gegners[i]!=null){
                if((gegners[i].xpos>=basex-gsize)&&(gegners[i].xpos<=basex+400+gsize)&&(gegners[i].ypos>=basey-gsize)&&(gegners[i].ypos<=basey+400+gsize)){
                    int xpg=(int)(gegners[i].xpos);
                    int ypg=(int)(gegners[i].ypos);
                    h.drawOval(xpg-gsize-basex,ypg-gsize-basey,gsize*2-1,gsize*2-1);
                    java.awt.Polygon pogi=new java.awt.Polygon();
                    double spitzex=Math.cos(gegners[i].alpha);
                    double spitzey=Math.sin(gegners[i].alpha);
                    double gleftx=Math.cos(gegners[i].alpha-2.0*Math.PI/3.0);
                    double glefty=Math.sin(gegners[i].alpha-2.0*Math.PI/3.0);
                    double grightx=Math.cos(gegners[i].alpha+2.0*Math.PI/3.0);
                    double grighty=Math.sin(gegners[i].alpha+2.0*Math.PI/3.0);
                    int xpo=xpg+((int)(gleftx*gsize))-basex;
                    int ypo=ypg+((int)(glefty*gsize))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=xpg+((int)(spitzex*gsize))-basex;
                    ypo=ypg+((int)(spitzey*gsize))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=xpg+((int)(grightx*gsize))-basex;
                    ypo=ypg+((int)(grighty*gsize))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=xpg+((int)(grightx*(gsize-gtness)))-basex;
                    ypo=ypg+((int)(grighty*(gsize-gtness)))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=xpg+((int)(spitzex*(gsize-gtness)))-basex;
                    ypo=ypg+((int)(spitzey*(gsize-gtness)))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=xpg+((int)(gleftx*(gsize-gtness)))-basex;
                    ypo=ypg+((int)(glefty*(gsize-gtness)))-basey;
                    pogi.addPoint(xpo,ypo);
                    h.fillPolygon(pogi);
                }
            }
        }
        h.drawOval(xposi-size-basex,yposi-size-basey,size*2-1,size*2-1);
        java.awt.Polygon ppogi=new java.awt.Polygon();
        double pspitzex=Math.cos(alpha);
        double pspitzey=Math.sin(alpha);
        double pleftx=Math.cos(alpha-Math.PI/2.0);
        double plefty=Math.sin(alpha-Math.PI/2.0);
        double prightx=Math.cos(alpha+Math.PI/2.0);
        double prighty=Math.sin(alpha+Math.PI/2.0);
        int pxpo=xposi+((int)(pleftx*size))-basex;
        int pypo=yposi+((int)(plefty*size))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=xposi+((int)(pspitzex*size))-basex;
        pypo=yposi+((int)(pspitzey*size))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=xposi+((int)(prightx*size))-basex;
        pypo=yposi+((int)(prighty*size))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=xposi+((int)(prightx*(size-tness)))-basex;
        pypo=yposi+((int)(prighty*(size-tness)))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=xposi+((int)(pspitzex*(size-tness)))-basex;
        pypo=yposi+((int)(pspitzey*(size-tness)))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=xposi+((int)(pleftx*(size-tness)))-basex;
        pypo=yposi+((int)(plefty*(size-tness)))-basey;
        ppogi.addPoint(pxpo,pypo);
        h.fillPolygon(ppogi);
        if(other){
            h.fillOval(xposi-size-basex,yposi-size-basey,size*2-1,size*2-1);
        }
        h.drawOval(xposib-size-basex,yposib-size-basey,size*2-1,size*2-1);
        java.awt.Polygon ppogib=new java.awt.Polygon();
        double pspitzexb=Math.cos(alphab);
        double pspitzeyb=Math.sin(alphab);
        double pleftxb=Math.cos(alphab-Math.PI/2.0);
        double pleftyb=Math.sin(alphab-Math.PI/2.0);
        double prightxb=Math.cos(alphab+Math.PI/2.0);
        double prightyb=Math.sin(alphab+Math.PI/2.0);
        int pxpob=xposib+((int)(pleftxb*size))-basex;
        int pypob=yposib+((int)(pleftyb*size))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=xposib+((int)(pspitzexb*size))-basex;
        pypob=yposib+((int)(pspitzeyb*size))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=xposib+((int)(prightxb*size))-basex;
        pypob=yposib+((int)(prightyb*size))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=xposib+((int)(prightxb*(size-tness)))-basex;
        pypob=yposib+((int)(prightyb*(size-tness)))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=xposib+((int)(pspitzexb*(size-tness)))-basex;
        pypob=yposib+((int)(pspitzeyb*(size-tness)))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=xposib+((int)(pleftxb*(size-tness)))-basex;
        pypob=yposib+((int)(pleftyb*(size-tness)))-basey;
        ppogib.addPoint(pxpob,pypob);
        h.fillPolygon(ppogib);
        if(other){
            h.fillOval(xposib-size-basex,yposib-size-basey,size*2-1,size*2-1);
        }
        String str1="";
        String str2="";
        String str3="";
        if(lifes>0){
            str1="Lifes: "+lifes;
            if(gleft>0){
                str2="Enemies left: "+gleft;
                str3="Destroyed: "+destroyed;
            }
            else{
                str2="You have won!";
                str3="Destroyed: "+destroyed;
            }
        }
        else{
            str1="You have lost!";
            str2="Enemies left: "+gleft;
            str3="Destroyed: "+destroyed;
        }
        h.drawString(str1,40,40);
        h.drawString(str2,40,60);
        h.drawString(str3,40,80);
        if(allbombsusedmessage){
            h.drawString("All bombs used! Recollect them or wait for collisions!",40,100);
        }
        if(fullsky){
            h.drawString("FULLSKY activated",40,120);
        }
        if(other){
            h.drawString("other steering activated",40,150);
        }
        h.setClip(400,0,400,400);
        basex=xposib-200;
        basey=yposib-200;
        for(int i=0;i<scount;i++){
            if(starsx[i]>=basex&&starsx[i]<=basex+400&&starsy[i]>=basey&&starsy[i]<=basey+400){
                h.fillRect(400+starsx[i]-basex,starsy[i]-basey,1,1);
            }
        }
        for(int i=0;i<bx;i++){
            for(int j=0;j<by;j++){
                if(fullsky==false&&isboden[i][j]){
                    int xp=xleft+i*20;
                    int yp=yleft+j*20;
                    if((xp>=(basex-20))&&(xp<=(basex+420))&&(yp>=(basey-20))&&(yp<=(basey+420))){
                        h.drawImage(hs.boden,400+xp-basex,yp-basey,this);
                    }
                }
            }
        }
        for(int i=0;i<bcount;i++){
            if(bombs[i]!=null){
                int xpb=bombs[i].xpos;
                int ypb=bombs[i].ypos;
                if((xpb>=(basex-20))&&(xpb<=(basex+420))&&(ypb>=(basey-20))&&(ypb<=(basey+420))){
                    h.drawImage(hs.bomb,400+xpb-basex-10,ypb-basey-10,this);
                }
            }
        }
        for(int i=0;i<gcount;i++){
            if(gegners[i]!=null){
                if((gegners[i].xpos>=basex-gsize)&&(gegners[i].xpos<=basex+400+gsize)&&(gegners[i].ypos>=basey-gsize)&&(gegners[i].ypos<=basey+400+gsize)){
                    int xpg=(int)(gegners[i].xpos);
                    int ypg=(int)(gegners[i].ypos);
                    h.drawOval(400+xpg-gsize-basex,ypg-gsize-basey,gsize*2-1,gsize*2-1);
                    java.awt.Polygon pogi=new java.awt.Polygon();
                    double spitzex=Math.cos(gegners[i].alpha);
                    double spitzey=Math.sin(gegners[i].alpha);
                    double gleftx=Math.cos(gegners[i].alpha-2.0*Math.PI/3.0);
                    double glefty=Math.sin(gegners[i].alpha-2.0*Math.PI/3.0);
                    double grightx=Math.cos(gegners[i].alpha+2.0*Math.PI/3.0);
                    double grighty=Math.sin(gegners[i].alpha+2.0*Math.PI/3.0);
                    int xpo=400+xpg+((int)(gleftx*gsize))-basex;
                    int ypo=ypg+((int)(glefty*gsize))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=400+xpg+((int)(spitzex*gsize))-basex;
                    ypo=ypg+((int)(spitzey*gsize))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=400+xpg+((int)(grightx*gsize))-basex;
                    ypo=ypg+((int)(grighty*gsize))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=400+xpg+((int)(grightx*(gsize-gtness)))-basex;
                    ypo=ypg+((int)(grighty*(gsize-gtness)))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=400+xpg+((int)(spitzex*(gsize-gtness)))-basex;
                    ypo=ypg+((int)(spitzey*(gsize-gtness)))-basey;
                    pogi.addPoint(xpo,ypo);
                    xpo=400+xpg+((int)(gleftx*(gsize-gtness)))-basex;
                    ypo=ypg+((int)(glefty*(gsize-gtness)))-basey;
                    pogi.addPoint(xpo,ypo);
                    h.fillPolygon(pogi);
                }
            }
        }
        h.drawOval(400+xposi-size-basex,yposi-size-basey,size*2-1,size*2-1);
        ppogi=new java.awt.Polygon();
        pspitzex=Math.cos(alpha);
        pspitzey=Math.sin(alpha);
        pleftx=Math.cos(alpha-Math.PI/2.0);
        plefty=Math.sin(alpha-Math.PI/2.0);
        prightx=Math.cos(alpha+Math.PI/2.0);
        prighty=Math.sin(alpha+Math.PI/2.0);
        pxpo=400+xposi+((int)(pleftx*size))-basex;
        pypo=yposi+((int)(plefty*size))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=400+xposi+((int)(pspitzex*size))-basex;
        pypo=yposi+((int)(pspitzey*size))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=400+xposi+((int)(prightx*size))-basex;
        pypo=yposi+((int)(prighty*size))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=400+xposi+((int)(prightx*(size-tness)))-basex;
        pypo=yposi+((int)(prighty*(size-tness)))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=400+xposi+((int)(pspitzex*(size-tness)))-basex;
        pypo=yposi+((int)(pspitzey*(size-tness)))-basey;
        ppogi.addPoint(pxpo,pypo);
        pxpo=400+xposi+((int)(pleftx*(size-tness)))-basex;
        pypo=yposi+((int)(plefty*(size-tness)))-basey;
        ppogi.addPoint(pxpo,pypo);
        h.fillPolygon(ppogi);
        if(other){
            h.fillOval(400+xposi-size-basex,yposi-size-basey,size*2-1,size*2-1);
        }
        h.drawOval(400+xposib-size-basex,yposib-size-basey,size*2-1,size*2-1);
        ppogib=new java.awt.Polygon();
        pspitzexb=Math.cos(alphab);
        pspitzeyb=Math.sin(alphab);
        pleftxb=Math.cos(alphab-Math.PI/2.0);
        pleftyb=Math.sin(alphab-Math.PI/2.0);
        prightxb=Math.cos(alphab+Math.PI/2.0);
        prightyb=Math.sin(alphab+Math.PI/2.0);
        pxpob=400+xposib+((int)(pleftxb*size))-basex;
        pypob=yposib+((int)(pleftyb*size))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=400+xposib+((int)(pspitzexb*size))-basex;
        pypob=yposib+((int)(pspitzeyb*size))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=400+xposib+((int)(prightxb*size))-basex;
        pypob=yposib+((int)(prightyb*size))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=400+xposib+((int)(prightxb*(size-tness)))-basex;
        pypob=yposib+((int)(prightyb*(size-tness)))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=400+xposib+((int)(pspitzexb*(size-tness)))-basex;
        pypob=yposib+((int)(pspitzeyb*(size-tness)))-basey;
        ppogib.addPoint(pxpob,pypob);
        pxpob=400+xposib+((int)(pleftxb*(size-tness)))-basex;
        pypob=yposib+((int)(pleftyb*(size-tness)))-basey;
        ppogib.addPoint(pxpob,pypob);
        h.fillPolygon(ppogib);
        if(other){
            h.fillOval(400+xposib-size-basex,yposib-size-basey,size*2-1,size*2-1);
        }
        String bstr1="";
        String bstr2="";
        String bstr3="";
        if(lifesb>0){
            bstr1="Lifes: "+lifesb;
            if(gleft>0){
                bstr2="Enemies left: "+gleft;
                bstr3="Destroyed: "+destroyed;
            }
            else{
                bstr2="You have won!";
                bstr3="Destroyed: "+destroyed;
            }
        }
        else{
            bstr1="You have lost!";
            bstr2="Enemies left: "+gleft;
            bstr3="Destroyed: "+destroyed;
        }
        h.drawString(bstr1,440,40);
        h.drawString(bstr2,440,60);
        h.drawString(bstr3,440,80);
        g.drawImage(hs.imgfr.img,0,0,this);
    }
}
class Gegner{
    double alpha;
    double xpos;
    double ypos;
    double xdrift;
    double ydrift;
    int gspeed;
    int xposi;
    int yposi;
    public Gegner(double xpos,double ypos,double alpha,int gspeed){
        this.xpos=xpos;
        this.ypos=ypos;
        this.alpha=alpha;
        this.gspeed=gspeed;
        xposi=(int)xpos;
        yposi=(int)ypos;
    }
    public void move(){
        xdrift=Math.cos(alpha)*gspeed;
        ydrift=Math.sin(alpha)*gspeed;
        xpos=xpos+xdrift;
        ypos=ypos+ydrift;
        xposi=(int)xpos;
        yposi=(int)ypos;
    }
}
class Bomb{
    int xpos;
    int ypos;
    boolean isover;
    public Bomb(int xpos,int ypos){
        this.xpos=xpos;
        this.ypos=ypos;
        isover=true;
    }
}
class ImgFrame extends Frame{
    Image img;
    public ImgFrame(){
        pack();
        img=createImage(1000,640);
    }
}
class KeyboardMapperApplet extends Panel{
    Label info;
    List l;
    Label aliasl;
    TextField aliastf;
    Label keyl;
    TextField keytf;
    Button add;
    Button remove;
    Button addspecial;
    Button apply;
    Button cancel;
    Button dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    String[]alias=new String[0];
    String[]key=new String[0];
    boolean[]special=new boolean[0];
    Applet applet;
    public KeyboardMapperApplet(Applet applet){
        resize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new Label("");
        l=new List();
        aliasl=new Label("alias key: ");
        aliastf=new TextField("");
        keyl=new Label("for key: ");
        keytf=new TextField("");
        add=new Button("add");
        remove=new Button("remove");
        addspecial=new Button("add special key");
        apply=new Button("apply");
        cancel=new Button("cancel");
        dontapply=new Button("don't apply");
        add(info);
        add(l);
        add(aliasl);
        add(aliastf);
        add(keyl);
        add(keytf);
        add(add);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.reshape(10,10,380,27);
        l.reshape(10,40,380,170);
        aliasl.reshape(10,220,80,27);
        aliastf.reshape(110,220,80,27);
        keyl.reshape(210,220,80,27);
        keytf.reshape(310,220,80,27);
        add.reshape(10,250,80,27);
        remove.reshape(110,250,80,27);
        addspecial.reshape(10,280,380,27);
        apply.reshape(10,310,80,27);
        cancel.reshape(210,310,80,27);
        dontapply.reshape(310,310,80,27);
        info.setBackground(Color.white);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public int getKeyCode(int a){
        byte[]by=new byte[1];
        by[0]=(byte)a;
        String s=new String(by);
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(s.equals(alias[i])){
                String sb=key[i];
                byte[]byb=sb.getBytes();
                return byb[0];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.removeAll();
        int n=key.length;
        for(int i=0;i<n;i++){
            if(!special[i]){
                l.addItem(alias[i]+" alias for "+key[i]);
            }
            else{
                byte[]by1=alias[i].getBytes();
                byte[]by2=key[i].getBytes();
                l.addItem("special key "+by1[0]+" alias for "+by2[0]);
            }
        }
    }
    public void loadfirst(){
        try{
            InputStream fis=getInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
            info.setText("keymapforus.ini not found");
        }
    }
    public void load(String filename){
        try{
            InputStream fis=getInputStream(filename);
            DataInputStream dis=new DataInputStream(fis);
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                if("false".equals(inp3)){
                    kmt.add(inp,inp2);
                }
                else{
                    kmt.addspecial(inp,inp2);
                }
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            l.removeAll();
            int n=alias.length;
            for(int i=0;i<n;i++){
                if(!special[i]){
                    l.addItem(alias[i]+" alias for "+key[i]);
                }
                else{
                    byte[]by1=alias[i].getBytes();
                    byte[]by2=key[i].getBytes();
                    l.addItem("special key "+by1[0]+" alias for "+by2[0]);
                }
            }
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.KEY_ACTION||evt.id==Event.KEY_PRESS){
            if(kstatus==1){
                aliasx=evt.key;
                kstatus=2;
                info.setText("type key");
            }
            else if(kstatus==2){
                int keyx=evt.key;
                kstatus=0;
                info.setText("special key added");
                info.setBackground(Color.white);
                byte[]by1=new byte[1];
                by1[0]=(byte)aliasx;
                String s1=new String(by1);
                byte[]by2=new byte[1];
                by2[0]=(byte)keyx;
                String s2=new String(by2);
                kmt.addspecial(s1,s2);
                l.addItem("special key "+((byte)aliasx)+" alias for "+((byte)keyx));
            }
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==add){
                String a=aliastf.getText();
                String b=keytf.getText();
                if((a.length()!=1)||(b.length()!=1)){
                    info.setText("Error: alias and key must have length 1");
                    return false;
                }
                kmt.add(a,b);
                l.addItem(a+" alias for "+b);
                aliastf.setText("");
                keytf.setText("");
            }
            if(evt.target==remove){
                int ind=l.getSelectedIndex();
                if(ind!=-1){
                    l.remove(ind);
                    kmt.remove(ind);
                }
            }
            if(evt.target==addspecial){
                info.setText("type alias");
                info.setBackground(Color.yellow);
                kstatus=1;
            }
            if(evt.target==apply){
                alias=kmt.alias;
                key=kmt.key;
                special=kmt.special;
                applyb=true;
                closed=true;
                hide();
            }
            if(evt.target==cancel){
                restorekmt();
                cancelb=true;
                closed=true;
                hide();
            }
            if(evt.target==dontapply){
                applyb=false;
                info.setText("KeyboardMapper isn't applied");
            }
        }
        return false;
    }
}
class KeyMapperTable{
    String[]alias=new String[0];
    String[]key=new String[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new String[0];
        key=new String[0];
        special=new boolean[0];
    }
    public void add(String a,String b){
        int n=alias.length;
        String[]aliasb=new String[n+1];
        String[]keyb=new String[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        aliasb[n]=a;
        keyb[n]=b;
        specialb[n]=false;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        String[]aliasb=new String[n+1];
        String[]keyb=new String[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        aliasb[n]=a;
        keyb[n]=b;
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            String[]aliasb=new String[n-1];
            String[]keyb=new String[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
